(*
   kisten version 1.2  Copyright (C) 1989-2004 Frank Reglin

   kisten is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   kisten is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with kisten; see the file COPYING.
*)
program kisten;
(* version 1.1  september 1989        frank reglin           *)
(* an Turbo 6 angepat: fr 18.11.91                          *)
(* version 1.2 : Turbo 7 + minicrt anstatt crt, fr 21.5.2004 *)

uses minicrt;


const
  tickdelay = 17; { tickdelay und timecount evtl. anpassen: alle 1 Sek. }
  timecount = 58; { 1 Minuspunkt, Reaktion auf Tasten nicht merkl. langsamer }
  maxebene = 50;
  pkteb=100; pktki=70; { Punkte f. Anfang/Abschluss e. Ebene bzw pro Kiste }
  carbeiter= '@'; cplatz= '+'; ckiste= '#'; cmauer= #178;
  p2: array[1..16] of integer = (
     1,      2,      4,      8,    $10,    $20,    $40,    $80,
  $100,   $200,   $400,   $800,  $1000,  $2000,  $4000,    0  );
  a: array[1..24,1..39] of char = (
    '|||||||||||||||||||||||||||||||||||||||',
    '|                                     |',
    '| |||||||||||||||||||||||||    #  #   |',
    '| |   ||||||   ||||||  +++|    # #    |',
    '| | |#       #  #      +++|    ##     |',
    '| | | || ||||||||||||  +++|    # #    |',
    '| | | ||    |||  ||||||||||    #  #   |',
    '| | | ||  #      # ||   # |    I      |',
    '| | |||||||||||||| |||||| |    S      |',
    '| |       # #         @   |    T      |',
    '| |||||||||||||||||||||||||    E      |',
    '|                              N      |',
    '|  Das sind Sie -> @ !                |',
    '|  Schieben Sie die Kisten  -> #      |',
    '|  zu ihren Lagerplaetzen -> +        |',
    '|                                     |',
    '|          (C) Frank Reglin 1989-2004 |',
    '|||||||||||||||||||||||||||||||||||||||',
    '|                                     |',
    '| version 1.2          PC             |',
    '|                      Textmodus      |',
    '|  frei nach                          |',
    '|     SOKO-BAN  von spectrum holobyte |',
    '|||||||||||||||||||||||||||||||||||||||'
                                  );

type
  zustand = (frei, platz, kiste, kiste_auf_platz, mauer);
  feld = array[0..17,0..20] of zustand; { [1..16,1..19] und Mauer ringsum }
  feldspeicher = array[1..19,0..2] of integer; { komprimierte Darstellung }
  string10 = string[10];
  spieler = record
              xyz: array[0..6] of integer;
              name : string10;
              ebene: byte;
              punkt: array[1..maxebene] of integer;
              kennung: integer
            end;
  zug = (hier, nord, sued, ost, west, escape);

var
  sp: spieler;
  eb: integer;
  fe: feld;
  status: feldspeicher;
  ax: 0..20; ay: 0..17; { Ort des Arbeiters }
  spielerdaten: file of spieler;
  ebenendaten : file of feldspeicher;
  geschafft: boolean;
  map: array[0..4] of zustand;
  zeichen: array[zustand] of char;
  as:array[1..20] of record na:string10; eb:byte; we:integer end;
  pos: integer;
  punkte:integer;
  time: byte;
  uhran: boolean;
  oldmode: integer;

procedure ende;
begin
  close(spielerdaten);
  gotoxy(1,24);
  textmode( oldmode );
  halt;
end;


procedure zeigepunkte;
begin
  gotoxy(28,20); write(punkte:5);
end;


function read_key:char;
var
  c: char;
begin
  if uhran then
  while not keypressed do
  begin
    delay(tickdelay);
    time:=time+1;
    if time=timecount then begin
                        time:=0;
                        if punkte>-600 then     (* 1.1 *)
                          punkte:=punkte-1;
                        zeigepunkte
                    end
  end;  (* while *)
  c:=readkey;
  if c = #0 then
    c := readkey;
  read_key:=c;
  if c= #3 then ende
end;

procedure readstr(var s:string10; var escape:boolean);
var
  c: char;
  i: integer;

begin
  escape:=false;
  i:=1;
  repeat
    c:=read_key;
    if c=#27 then escape:=true;
    if c=^H then begin
                   if i>1 then begin
                                 i:=i-1;
                                 write(c)
                               end
                 end
      else if (c>=' ') and (c<='}') and (i<=10) then
        begin
          s[i]:=c;
          i:=i+1;
          write(c)
        end;
  until ((i>=1) and (c=^M)) or escape;
  s[0]:=chr(i-1);
end;


function gesamt(var sp:spieler): integer;
var
  n,s: integer;
begin
  with sp do
  begin
    s:=0;
    for n:=1 to ebene do  s:=s+punkt[n];
  end;
  gesamt:=s
end;


procedure einsort(var hwm:byte;max:byte;n:string10;e:byte;w:integer);
label 1;
var
  i,j: byte;
begin
  for i:=1 to hwm do
    if w>as[i].we then goto 1;
  i:=hwm+1;
  if i=max+1 then i:=max;
1:if hwm=max then hwm:=max-1;
  for j:=hwm downto i do
    as[succ(j)]:=as[j];
  with as[i] do  begin na:=n; eb:=e; we:=w end;
  hwm:=hwm+1;
end;


procedure statistik;
var
  i,n,hwm: byte;

begin
  seek(spielerdaten,0);
  clrscr;
  n:=0;
  hwm:=0;
  while (not eof(spielerdaten)) do
    with sp do
    begin
      read(spielerdaten,sp);
      einsort(hwm,20,name,ebene,gesamt(sp));
      n:=n+1;
    end;
  if n>0 then
  begin
    if n>20 then n:=20;
    writeln('Ebene':20,'Punkte':8); writeln;
    for i:=1 to n do
      with as[i] do
        writeln(i:2,'. ',na:10,eb:6,we:8);
    delay(600+100*n);
  end;
end;


procedure bildneu;
var
  x,y,i,n,hwm: byte;
  s: spieler;

begin
  clrscr;
  for y:=1 to 16 do
  begin
    gotoxy(1,y);
    for x:=1 to 19 do  write(zeichen[fe[y,x]]);
  end;
  gotoxy(ax,ay);
  write(carbeiter);

  gotoxy(22,3); write('Ebene',eb:3);
  with sp do
  begin
    gotoxy(3,18); write(name);
    gotoxy(4,20); write('gesamt    hier');
    gotoxy(4,22); write(gesamt(sp):6, punkt[eb]:8);
  end;
  gotoxy(26,18); write('*********');
  for y:=19 to 21 do
  begin
    gotoxy(26,y); write('*'); gotoxy(34,y); write('*');
  end;
  gotoxy(26,22); write('*********');
  seek(spielerdaten,0);
  n:=1;
  hwm:=0;
  while (not eof(spielerdaten)) do
    with s do
    begin
      read(spielerdaten,s);
      einsort(hwm,3,name,0,punkt[eb]);
      n:=n+1;
    end;
  if n<=3 then n:=n-1 else n:=3;
  for i:=1 to n do
    with as[i] do
    begin
      gotoxy(24,5+i); write(na:10,we:6);
    end;
end;


function machespiel(mensch:boolean):boolean;
var
  dx,dy,nk,nok: integer;
  z: zug;
  f, g: zustand;
  ok: boolean;

procedure gehe(x1,y1,x2,y2:integer);
begin
  gotoxy(x2,y2); write(carbeiter);
  gotoxy(x1,y1); if fe[y1,x1] = frei then  write(' ')
                                     else  write(cplatz);
end;

procedure schiebe(x1,y1,x2,y2: integer; z:zug);
var
  x3,y3:integer;
begin
  x3:=x2+x2-x1; y3:=y2+y2-y1;
  fe[y3,x3]:=succ(succ(fe[y3,x3]));
  fe[y2,x2]:=pred(pred(fe[y2,x2]));

  gotoxy(x3,y3); write(ckiste);
  gehe(x1,y1,x2,y2)
end;

function eingabe:zug;
var
  c: char;
begin
  if mensch
  then repeat
         c:=read_key;
              if c=#27 then eingabe:=escape
         else if (c='H') or (c='8') then eingabe:=nord
         else if (c='P') or (c='2') then eingabe:=sued
         else if (c='M') or (c='6') then eingabe:=ost
         else if (c='K') or (c='4') then eingabe:=west
         else  c:=#0;
       until c<>#0
  else if keypressed (* or (punkte<-100) *) then eingabe:=escape
       else begin
              delay(1000);
              case random(4) of
                0: eingabe:=nord;
                1: eingabe:=sued;
                2: eingabe:=ost;
                3: eingabe:=west
              end (* case *)
            end
end; { eingabe }

function schiebepunkte(a,b:zustand):integer;
begin
  case ord(a)*(ord(b)+1) of
    2,6: schiebepunkte:=0;   { kiste->frei, kiste_auf_platz->platz }
    4:   begin  nok:=nok+1; schiebepunkte:=pktki  end;  { kiste->platz }
    3:   begin  nok:=nok-1; schiebepunkte:=-pktki end   { kiste_auf_platz->frei }
  end
end;

begin  { machespiel }
  { Feststellen: wieviel Kisten (nk) ? wieviel Kisten richtig (nok) ? }
  nk:=0; nok:=0;
  for dx:=1 to 19 do
    for dy:=1 to 16 do
      begin
        f:=fe[dy,dx];
        if f=kiste_auf_platz
        then begin
               nk:=nk+1;
               nok:=nok+1;
             end
        else if f=kiste then nk:=nk+1;
      end;
  punkte:=pkteb+pktki*nok+1;
  { nun spielen bis nok=nk oder escape }
  uhran:=true;
  uhran:=false; (* ohne Zeitwertung ! *)
  z:=hier;
  while (nok<>nk) and (z<>escape) do
  begin
    dx:=0; dy:=0;
    case z of
      nord: dy:= -1;
      sued: dy:=  1;
      ost : dx:=  1;
      west: dx:= -1;
      hier,escape:
    end; (* case z *)
    f:=fe[ay+dy,ax+dx];
    case f of
      frei,platz:      begin
                         if z<>hier then gehe(ax,ay,ax+dx,ay+dy);
                         if punkte>-600 then     (* 1.1 *)
                           punkte:=punkte-1;
                         zeigepunkte
                       end;
      mauer:           begin  dx:=0; dy:=0  end;
      kiste,
      kiste_auf_platz: begin
                         g:=fe[ay+2*dy,ax+2*dx];
                         if g<=platz
                         then begin
                                schiebe(ax,ay,ax+dx,ay+dy,z);
                                punkte:=punkte+schiebepunkte(f,g);
                                zeigepunkte
                              end
                         else begin  dx:=0; dy:=0  end
                       end;
    end; (* case fe[] *)
    ax:=ax+dx; ay:=ay+dy;
    ok:= nok=nk;
    if ok then begin
                 punkte:=punkte+pkteb; zeigepunkte;
                 gotoxy(26,24);
                 delay(100);
                 write(chr(7),chr(7),chr(7));
                 delay(100);
                 write('GESCHAFFT');
                 sound( 300 );
                 delay(1000);
                 sound( 400 );
                 delay(1000);
                 nosound;
               end
          else  z:=eingabe;
  end; (* while *)
  uhran:=false;
  machespiel:=ok;
end;


procedure liesebene(nr:integer; var d:feldspeicher);
begin
  seek(ebenendaten,nr-1);
  read(ebenendaten,d);
end;

procedure auspacken(c:feldspeicher; var f:feld);
var
  x,y,k:integer;
begin
  for y:=1 to 16 do
  begin
    for x:=1 to 19 do
    begin
      k:=4*ord(odd(c[x,2]))+2*ord(odd(c[x,1]))+ord(odd(c[x,0]));
      if k<=4 then f[y,x]:=map[k]
              else begin
                     f[y,x]:=map[k-6];
                     ax:=x;
                     ay:=y;
                   end;
      for k:=0 to 2 do  c[x,k]:=c[x,k] shr 1;
    end;
  end
end;

procedure anfangsbild;
var
  x,y: integer;
  c: char;
  dummy: boolean;

begin
  clrscr;
  for y:=1 to 24 do
  begin
    for x:=1 to 39 do
    begin
      c:=a[y,x];
           if c='|' then c:=cmauer
      else if c='#' then c:=ckiste
      else if c='+' then c:=cplatz
      else if c='@' then c:=carbeiter;
      write(c)
    end;
    writeln
  end;
  randomize;
  for x:=0 to mem[$40:$6C] do y:=random(maxebene);
  x := 1;
  repeat
     delay(1000);
     x := x + 1;
  until (x = 10) or keypressed;
  if keypressed then
     c:=readkey;
  with sp do
  begin
    eb:=random(maxebene)+1;
    liesebene(eb,status);
    auspacken(status,fe);
    name:='Reiner Z.';
    ebene:=eb+random(maxebene-eb);
    for x:=1 to ebene do punkt[x]:=random(2*(pkteb+pktki))+pkteb;
    bildneu;
    dummy:=machespiel(false);  { Demo bis ein Taste gedrueckt wird }
  end;
  if keypressed then
     c:=readkey;
end;


procedure fenster;
var
  y: integer;
begin
  gotoxy(8, 9);write('                            ');
  gotoxy(8,10);write('  ------------------------  ');
for y:=11 to 17 do
begin
  gotoxy(8, y);write(' |                        | ');
end;
  gotoxy(8,18);write('  ------------------------  ');
  gotoxy(8,19);write('                            ');
end;


function suche(n:string10):integer;
label 1;
var
  p:integer;
  s:spieler;
begin
  seek(spielerdaten,0);
  p:=0;
  while not eof(spielerdaten) do
  begin
    read(spielerdaten,s);
    if s.name=n then begin
                       suche:=p;
                       goto 1
                     end;
    p:=p+1;
  end;
  suche:= -1;
1:
end;


procedure neuerspieler(var sp:spieler);
var
  e: byte;
  escape: boolean;

function geheim: integer;
var
  n: integer;
  z: integer;
begin
  n:=ord(sp.name[0]);
  z:=3141;
  for n:=n downto 1 do z:=z+n*ord(sp.name[n]);
  n:=z mod 13 + 17;
  for n:=n to n+3 do  z:=z+n*ord(read_key);
  geheim:=z
end;

begin
  fenster;
  with sp do
  begin
    gotoxy(11,12); write('Wer spielt nun ?');
    gotoxy(11,15); write(' <Esc> = Ende');
    repeat
       gotoxy(11,13); readstr(name,escape);
       if escape then ende;
    until length( name ) > 0;
    pos:=suche(name);
    if pos<0 (* nicht gefunden *)
    then begin
           ebene:=1;
           for e:=1 to maxebene do punkt[e]:=0;
           gotoxy(11,14); write('Neuer Spieler !');
           repeat
             gotoxy(11,15); write(' Bitte eine 4-stellige');
             gotoxy(11,16); write(' Geheimzahl eingeben :');
             kennung:=geheim;
             gotoxy(11,15); write(' Bitte die Zahl jetzt ');
             gotoxy(11,16); write(' nochmal wiederholen :');
          until kennung=geheim
        end
    else begin
           seek(spielerdaten,pos);                     (* 1.1 *)
           read(spielerdaten,sp);                      (* 1.1 *)
           gotoxy(11,15); write(' Geben Sie jetzt bitte');
           gotoxy(11,16); write(' Ihre Geheimzahl ein:');
           if kennung<>geheim then begin
                                     gotoxy(11,14); write('Tut mir leid ...');
                                     ende
                                   end
         end
  end (* with *)
end;

procedure schreibspieler(s:spieler);
begin
  if pos<0 then pos:=filesize(spielerdaten);
  seek(spielerdaten,pos);
  write(spielerdaten,s);
end;

function neuebene:integer;
var
  e: string10;
  n, err:integer;
  escape: boolean;

begin
  fenster;
  gotoxy(11,12); write('In welche Ebene ?');
  gotoxy(11,13); write(' (Nummer oder <Enter>)');
  gotoxy(11,14); write(' <Enter> = ',eb:2);
  gotoxy(11,15); write(' 0 = anderer Spieler');
  gotoxy(11,16); write(' -1= Ende');
  repeat
    gotoxy(29,12); write('  ');        (* 1.1 *)
    gotoxy(29,12); readstr(e,escape);
    if (length(e)=0) or escape then begin n:=eb; err:=0 end
                               else val(e,n,err);
    if (n<0) and (err=0) then ende;
  until (n<=sp.ebene) and (err=0);
  neuebene:=n;
end;

begin (* MAIN *)
   p2[16] := p2[15] * 2;
   oldmode := lastmode;
   textmode( CO40 );
   map[0]:=frei;  map[1]:=platz;
   map[2]:=kiste; map[3]:=kiste_auf_platz;
   map[4]:=mauer;
   zeichen[frei] :=' ';    zeichen[platz]:=cplatz;
   zeichen[kiste]:=ckiste; zeichen[kiste_auf_platz]:=ckiste;
   zeichen[mauer]:=cmauer;
   for ax:=0 to 20 do  begin fe[0,ax]:=mauer; fe[17,ax]:=mauer end;
   for ay:=1 to 16 do  begin fe[ay,0]:=mauer; fe[ay,20]:=mauer end;
   assign(ebenendaten,'kisten.dat');
   assign(spielerdaten,'spieler.dat');
   reset(ebenendaten);
   {$I-} reset(spielerdaten); {$I+}
   if ioresult<>0 then rewrite(spielerdaten);
  time:=0;
  anfangsbild;
  uhran:=false;
  repeat
    statistik;
    neuerspieler(sp);
    with sp do
    begin
      eb:=ebene;
      repeat
        liesebene(eb,status);
        auspacken(status,fe);
        bildneu;
        geschafft:=machespiel(true);
        if (punkte>punkt[eb]) or (geschafft and (eb=ebene))
          then begin
                 punkt[eb]:=punkte;
                 gotoxy(4,22); write(gesamt(sp):6, punkte:8);
                 schreibspieler(sp);
               end;
        if geschafft and (eb<maxebene)
          then begin
                 eb:=eb+1;
                 if eb>ebene then ebene:=eb;
               end
          else  eb:=neuebene; { kann auch 0 ergeben -> neuer Spieler }
      until eb=0;
    end; (* with *)
  until false
end.
